/**
Copyright 2021 Forestry.io Holdings, Inc.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
    http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
export declare type RepoInfo = {
    username: string;
    name: string;
    branch: string;
    filePath: string;
};
export declare function isUrlOk(url: string): Promise<boolean>;
export declare function getRepoInfo(url: URL, examplePath?: string): Promise<RepoInfo | undefined>;
export declare function hasRepo({ username, name, branch, filePath, }: RepoInfo): Promise<boolean>;
export declare function hasExample(name: string): Promise<boolean>;
export declare function downloadAndExtractRepo(root: string, { username, name, branch, filePath }: RepoInfo): Promise<void>;
export declare function downloadAndExtractExample(root: string, name: string): Promise<void>;
